<template>
  <component :is="componentTag" v-bind="componentProps" @click="interceptClick">
    <span v-if="$slots.left">
      <!-- @slot Use this slot for custom icons (i.e.: with custom classes) -->
      <slot name="left" :title="caption" />
    </span>
    <rui-icon v-else-if="icon" :name="icon" :title="caption || ''" />

    <!-- @slot Visible text -->
    <span v-if="caption || $slots.default" class="rui-button__text"><slot>{{ caption }}</slot></span>

    <span v-if="$slots.right">
      <!-- @slot Use this slot for custom icons (i.e.: with custom classes) -->
      <slot name="right" />
    </span>
    <rui-icon v-else-if="endIcon" :name="endIcon" />
  </component>
</template>

<script>
import RuiIcon from '../Icon/Icon.vue'

const baseVariants = ['destructive', 'creative', 'recording', 'canceling', 'helping', 'dim']
export const variants = [...baseVariants, ...baseVariants.map(v => `${v}-text`)]
export const sizes = ['small', 'large']
export const types = ['button', 'submit', 'reset']

/**
 * Button component with support for `vue-router` links, anchor links and more !
 *
 * @preset Default { "props": { "caption": "Click me!" } }
 * @propsGroup Display  [variant, size, block, text, type]
 * @propsGroup State    [active, disabled, waiting]
 * @propsGroup Behavior [noAction, noTextOnSmall]
 * @propsGroup Content  [caption, icon, endIcon, to, href]
 */
export default {
  name: 'RuiButton',
  emits: [
    /**
     * Triggered on click unless the button is disabled
     *
     * @event click
     * @param {Event} event - The click event
     */
    'click',
  ],
  components: { RuiIcon },
  props: {
    /** Main content. Will be overridden by default slot content */
    caption: { required: false, type: [String, Number], default: null },
    /**
     * Color variant. `*-text` baseVariants are incompatible with the `text` prop.
     *
     * @values destructive, destructive-text, creative, creative-text, recording, recording-text, canceling, canceling-text, helping, helping-text, dim, dim-text
     */
    variant: { required: false, type: String, default: null, validator: v => variants.includes(v) },
    /**
     * Button size
     *
     * @values small, large
     */
    size: { required: false, type: String, default: null, validator: v => sizes.includes(v) },
    /** Takes full available width */
    block: { required: false, type: Boolean, default: false },
    /** Whether the button is rendered without background */
    text: { required: false, type: Boolean, default: false },
    /** Force active state */
    active: { required: false, type: Boolean, default: false },
    /** Makes the button non-responsive to clicks. Useful with "blank" icons */
    noAction: { required: false, type: Boolean, default: false },
    /** Left icon name */
    icon: { required: false, type: String, default: null },
    /** Right icon name */
    endIcon: { required: false, type: String, default: null },
    /** Router-link route. Will render a link styled like a button. */
    to: { required: false, type: [Object, String], default: null },
    /** Link URL. Will render a link styled like a button. */
    href: { required: false, type: String, default: null },
    /**
     * Button type (will be ignored when used with `to` or `href`)
     *
     * @values button, submit, reset
     */
    type: { required: false, type: String, default: 'button', validator: v => types.includes(v) },
    /** Whether to hide the text on small screens */
    noTextOnSmall: { required: false, type: Boolean, default: false },
    /** Whether to disable the button/link */
    disabled: { required: false, type: Boolean, default: false },
    /** Whether to make the button in a waiting state. Takes precedence over `disabled` prop */
    waiting: { required: false, type: Boolean, default: false },
  },
  computed: {
    isDisabled () { return this.disabled || this.waiting },
    componentTag () {
      if (this.to) {
        return this.isDisabled ? 'a' : 'RouterLink'
      }
      if (this.href) return 'a'

      return 'button'
    },
    componentProps () {
      const props = {
        class: [
          'rui-button',
          this.size && `rui-button--${this.size}`,
          this.block && 'rui-button--block',
          this.text && 'rui-button--text',
          this.active && 'rui-button--active',
          this.noAction && 'rui-button--no-action',
          this.noTextOnSmall && 'rui-button--no-text-on-small',
          this.isDisabled && 'rui-button--disabled',
          this.waiting && 'rui-button--waiting',
          variants.includes(this.variant) && this.text && `rui-button--text--${this.variant}`,
          variants.includes(this.variant) && !this.text && `rui-button--${this.variant}`,
        ],
        disabled: this.isDisabled,
      }

      if (this.to || this.href) {
        // Don't create links when disabled
        if (this.to && !this.isDisabled) {
          props.to = this.to
        } else if (this.href && !this.isDisabled) {
          props.href = this.href
        }
      } else {
        props.type = this.type
      }

      return props
    },
  },
  methods: {
    interceptClick (event) {
      if (this.isDisabled) {
        event.preventDefault()
        return
      }

      this.$emit('click', event)
    },
  },
}
</script>
